<?php

include_once('Common/RSS.php');

class LogShow extends Page
{
  var $FullTitle = 'Zobrazení záznamu operací';
  var $ShortTitle = 'Záznam operací';
  var $RowPerPage = 20;

  function Show()
  {
    if(count($this->System->PathItems) > 1)
    { 
      if($this->System->PathItems[1] == 'rss') return($this->ShowRSS());
        else return(PAGE_NOT_FOUND);
    } else return($this->ShowList());
  }
  
  function ShowRSS()
  {
    $this->SimplePage = true;
    $this->FormatHTML = false;
    
    if(!$this->System->Models['User']->CheckPermission('Log', 'Show')) return('Nemáte oprávnění');
    $DbResult = $this->Database->query('SELECT UNIX_TIMESTAMP(Time), Log.*, `User`.`Name` as UserName FROM `Log` LEFT JOIN `User` ON `User`.`Id` = `Log`.`User` ORDER BY Time DESC LIMIT 0, 50');
    while($Row = $DbResult->fetch_assoc())
    {
      $Info = $Row['UserName'].': '.$Row['Module'].' '.$Row['Operation'].' '.$Row['Value'];
      $Items[] = array
      (
        'Title' => $Info,
        'Link' => 'http://'.$this->System->Config['Web']['Host'].'/',
        'Description' => $Info,
        'Time' => $Row['UNIX_TIMESTAMP(Time)'],
      );
    }
    $RSS = new RSS();
    $RSS->Title = $this->System->Config['Web']['Title'].' - Záznamy operací';
    $RSS->Link = 'http://'.$this->System->Config['Web']['Host'].'/'; 
    $RSS->Description = 'Záznamy operací'; 
    $RSS->WebmasterEmail = $this->System->Config['Web']['AdminEmail']; 
    $RSS->Items = $Items;
    return($RSS->Generate());      
  }
  
  function ShowList()
  {
    if(!$this->System->Models['User']->CheckPermission('Log', 'Show')) return('Nemáte oprávnění');
    $DbResult = $this->Database->select('Log', 'COUNT(*)');
    $RowTotal = $DbResult->fetch_array();
    $PageMax = $RowTotal[0];
    if(array_key_exists('Page', $_GET)) $Page = $_GET['Page']; else $Page = 0;

    $Output = '<div align="center"><table class="WideTable" style="font-size: small;">';
    $Output .= '<tr><th>Čas</th><th>Uživatel</th><th>Modul</th><th>Operace</th><th>Hodnota</th></tr>';
    $DbResult = $this->Database->query('SELECT Log.*, `User`.`Name` as UserName FROM `Log` LEFT JOIN `User` ON `User`.`Id` = `Log`.`User` ORDER BY Time DESC LIMIT '.$Page * $this->RowPerPage.','.$this->RowPerPage);
    while($DbRow = $DbResult->fetch_assoc())
    {
      $Output .= '<tr><td>'.$DbRow['Time'].'</td><td>'.$DbRow['UserName'].'</td><td>'.$DbRow['Module'].'</td><td>'.$DbRow['Operation'].'</td><td>'.$DbRow['Value'].'</td></tr>';
    }
    $Output .= '</table>';
    $Output .= PagesList('?Page=', $Page, $PageMax, $this->RowPerPage);
    $Output .= '</div>';
    return($Output);
  }
}

class Log extends Model
{
  function __construct($Database, $System)
  {
    parent::__construct($Database, $System);
    $this->Name = 'Log';
    $this->AddPropertyDateTime('Time');
    $this->AddPropertyOneToMany('User', 'User');
    $this->AddPropertyString('Module');
    $this->AddPropertyString('Operation');
    $this->AddPropertyString('Value');
  }
}

class ModuleLog extends Module
{
  function __construct($Database, $System)
  {
    parent::__construct($Database, $System);
    $this->Name = 'Log';
    $this->Version = '1.0';
    $this->Creator = 'Chronos';
    $this->License = 'GNU/GPL';
    $this->Description = 'Logging of user operations';
    $this->Dependencies = array('User');
    $this->SupportedModels = array('Log');
  }
  
  function Install()
  {
    parent::Install();
  }
  
  function UnInstall()
  {
    parent::UnInstall();
  }

  function Start()
  {
    parent::Start();
    $this->System->Pages['log'] = 'LogShow';
  }

  function NewRecord($Module, $Operation, $Value = '')
  {
    $this->Database->insert('Log', array('Time' => 'NOW()', 
      'User' => $this->System->Module['User']->Models['User']->User['Id'], 'Module' => $Module, 
      'Operation' => $Operation, 'Value' => $Value));
    //echo($this->Database->LastQuery);
  }
}

?>